<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="backLink"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomAlert
            v-if="fetchError"
            :alert-type="AlertType.Error"
            :message="fetchError"
          />

          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <InterviewForm
            v-else-if="interview && followUpTypes && prescribingOrganisations"
            :is-submitting="isSubmitting"
            :follow-up-types="followUpTypes"
            :prescribing-organisations="prescribingOrganisations"
            :interview="interview"
            :beneficiary-id="beneficiaryId"
            @save-interview="onUpdateInterview"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { beneficiaryName } from '~/utils/beneficiary'
  import { BeneficiaryTab } from '~/utils/constants/beneficiary-tabs'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { Routes } from '~/utils/routing/routes'

  definePageMeta({
    middleware: ['owns-interview', 'is-beneficiary-referent']
  })

  const route = useRoute()
  const {
    $getItem,
    $loadOrganisationFollowUpTypes,
    $loadPrescribingOrganisations,
    $updateItem,
    $snackbar
  } = useNuxtApp()

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const interviewId = computed(() => route.params.iid)

  const {
    data: interview,
    pending: interviewPending,
    error: interviewError
  } = useLazyAsyncData(
    getRandomId(`interview-${interviewId.value}`),
    loadInterview,
    { server: false }
  )

  const {
    data: followUpTypes,
    pending: followUpTypesPending,
    error: followUpTypesError
  } = useLazyAsyncData(
    getRandomId('followUpTypes'),
    $loadOrganisationFollowUpTypes,
    { server: false }
  )

  const {
    data: prescribingOrganisations,
    pending: prescribingOrganisationsPending,
    error: prescribingOrganisationsError
  } = useLazyAsyncData(
    getRandomId('prescribingOrganisations'),
    $loadPrescribingOrganisations,
    { server: false }
  )

  const pending = computed(
    () =>
      interviewPending.value ||
      followUpTypesPending.value ||
      prescribingOrganisationsPending.value
  )

  const fetchError = computed(() => {
    if (interviewError.value) {
      return "La synthèse de l'entretien n'a pas pu être chargée."
    }
    if (followUpTypesError.value) {
      return "La liste des types d'accompagnement de votre structure n'a pas pu être chargée."
    }
    if (prescribingOrganisationsError.value) {
      return "La liste des organismes prescripteurs de votre structure n'a pas pu être chargée."
    }
    return ''
  })

  const title = computed(() => {
    if (!interview.value) {
      return "Modifier l'entretien avec un·e bénéficiaire"
    }
    const { beneficiary } = interview.value
    return `Modifier l'entretien avec ${beneficiaryName(beneficiary)}`
  })

  const beneficiaryId = computed(() => route.params.id)

  const beneficiaryPath = computed(() =>
    Routes.Beneficiary(beneficiaryId.value)
  )

  const backLink = computed(
    () =>
      `${beneficiaryPath.value}?tab=${BeneficiaryTab.History}&item=${interviewId.value}`
  )

  async function loadInterview() {
    const fields = [
      '*',
      'private_synthesis.id',
      'private_synthesis.private_synthesis',
      'beneficiary.id',
      'beneficiary.firstname',
      'beneficiary.usual_name',
      'follow_up_types.id',
      'follow_up_types.follow_up_types_id',
      'documents.id',
      'documents.directus_file',
      'documents.directus_file',
      'documents.directus_file'
    ]
    const res = await $getItem('follow_ups', interviewId.value, {
      fields
    })

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  async function onUpdateInterview(_interview) {
    isSubmitting.value = true
    try {
      const res = await $updateItem('follow_ups', interview.value, _interview)

      if (res.status === 200) {
        return navigateTo(
          `${beneficiaryPath.value}?tab=${BeneficiaryTab.History}`
        )
      }
      throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.success('La mise à jour de la synthèse a échoué.', () =>
        formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
